/*** Save - A program for saving diskettes as a disk file.
 *
 *      Call:   Save
 */

#define AREAD   0x25    /* absolute disk read interrupt code */
#define AWRITE  0x26    /* absolute disk write interrupt code */
#define SECTOR  512     /* sector size */
#define IOS     48      /* memory buffer size (sectors) */
#define SPB     (1024/SECTOR)   /* no of sectors per 1K blocks */

#include  <stdio.h>
#include  <conio.h>
#include  <dos.h>

typedef char  BYTE;     /* 8 bits */

BYTE    buf1 [IOS*SECTOR], buf2 [IOS*SECTOR];


int     equal (p, q, s) /* general purpose copy */
register BYTE  *p, *q;
register  s;
{
  while (s--)
    if (*p++ != *q++)  return 0;
  return 1;
}  /* equal */


int     adisk (intno, driveno, seccnt, secno, traddr)
BYTE  *traddr;
{
  union REGS  r;
  int  adsk ();         /* assembly function */

  r.h.ah = (BYTE) intno;
  r.h.al = (BYTE) (driveno -'A');
  r.x.cx = seccnt;
  r.x.dx = secno;
  r.x.bx = (unsigned) traddr;
  return (adsk (r));    /* 1 error; 0 ok */
}  /* adisk */


int     menu ()
{
  int  opt;
  static char  *chs[] = {
        "\n",
        "1.  Save \tDiskette --> Disk",
        "2.  Get  \tDiskette <-- Disk",
        "3.  Compare\tDiskette <-> Disk" };

  printf ("\n\n\t%s\n\t%s\n\t%s\n\nChoice: ", chs[1], chs[2], chs[3]);
  if ((opt=getch()) == '1' || opt == 'S' || opt == 's')
    opt = 1;
  else if (opt == '2' || opt == 'G' || opt == 'g')
    opt = 2;
  else if (opt == '3' || opt == 'C' || opt == 'c')
    opt = 3;
  else
    opt = 0;
  puts (chs [opt]);
  return opt;
}  /* menu */


int     askdr ()
{
  int  dr;

  printf ("Diskette drive (A/B): ");
  if ((dr = toupper (getch())) != 'A' && dr != 'B')
    dr = 0;
  printf (dr ? "%c:\n" : "\n", dr);
  return  dr;
}  /* askdr */


char   *askfn ()
{
  static char  fn [65+3] = { 65 };

  printf ("Disk file name: ");
  cgets (fn);
  putchar ('\n');
  return  fn [2] ? fn+2 : NULL;
}  /* askfn */



void    main ()
{
  int  choice, drive;
  char  *fn;
  FILE  *fp;

  static char  cm [20] = " (c)";
  char   *cp = cm+3;
  static long  l = 0xB0EF4560,  s = 0x09C56941; /* magic numbers */
  int    i, b = 0, f1, f2;

  for (i = 1; i < 16; i++) {
    if (i==9)
      l = s;
    *++cp = (int) (l & 0xFL) + 'a' - 1 - b;
    l >>=4 ;
    if (*cp == 'a'-1) {
      b = 'a'-'A';
      *cp = ' ';
    }  /* if */
    else  b = 0;
  }  /* for */

  printf ("--- SAVE DISKETTES AS FILES PROGRAM -%s 1989 ---\n\n", cm);

  while ((choice = menu ()) != 0)
    while ((drive = askdr ()) != 0)
      while ((fn = askfn ()) != NULL) {
        i = 0;
        if (choice == 1) {
          if (!access (fn, 0)) {
            printf ("File '%s' already present!\nEnter NEW ", fn);
            continue;
          }
          if ((fp = fopen (fn, "wb")) == NULL) {
            printf ("File '%s' cannot be opened!\nEnter ANOTHER ", fn);
            continue;
          }
          while (!adisk (AREAD, drive, IOS, i, buf1) &&
                 (f1 = fwrite (buf1, SECTOR, IOS, fp) == IOS))
            printf ("\r%d", (i+=IOS)/SPB);
          printf (f1 ? " blocks saved on disk file '%s'.\n"
                     : ".  Write error on file '%s'!\a\n" , fn);
        } else  {
          if (access (fn, 4)) {
            printf ("File '%s' cannot be accessed!\nEnter EXISTENT ",fn);
            continue;
          }
          if ((fp = fopen (fn, "rb")) == NULL) {
            printf ("File '%s' cannot be opened!\nEnter ANOTHER ", fn);
            continue;
          }
          if (choice == 2) {
            while (fread (buf1, SECTOR, IOS, fp) == IOS &&
                   !(f1 = adisk (AWRITE, drive, IOS, i, buf1)))
              printf ("\r%d", (i+=IOS)/SPB);
            printf (f1 ? ".  Write error on diskette!\a\n" :
                         " blocks loaded to diskette.\n");
          }  else {  /* (choice == 3) */
            while (!(f1 = adisk (AREAD, drive, IOS, i, buf1)) *
                   (f2 = (fread (buf2, SECTOR, IOS, fp) == IOS))
                   && (b = equal (buf1, buf2, IOS*SECTOR)))
              printf ("\r%d", (i+=IOS)/SPB);
            printf (
              !b  ? ".  Compare error!\a\n" :
              !f1 ? ".  File is shorter than diskette!\a\n" :
              f2  ? ".  Diskette is shorter than file!\a\n" :
                   " blocks compare OK.\n");
          }
        }  /* if */
        fclose (fp);
      }  /* while */
  printf ("\n\n--- OPERATION COMPLETED NORMALLY ---\n");
  exit (0);
}  /* main */
